diff -aburN dokuwiki-2008-05-05/inc/common.php dokuwiki/inc/common.php
--- dokuwiki-2008-05-05/inc/common.php	2008-05-05 19:10:09.000000000 +0200
+++ dokuwiki/inc/common.php	2008-05-25 20:19:09.000000000 +0200
@@ -271,7 +271,7 @@
   }
   //we only save on show and existing wiki documents
   $file = wikiFN($ID);
-  if($ACT != 'show' || !@file_exists($file)){
+  if($ACT != 'show' || !@file_exists($file) || auth_quickaclcheck($ID) < AUTH_READ ){
     $_SESSION[DOKU_COOKIE]['bc'] = $crumbs;
     return $crumbs;
   }
diff -aburN dokuwiki-2008-05-05/inc/parser/xhtml.php dokuwiki/inc/parser/xhtml.php
--- dokuwiki-2008-05-05/inc/parser/xhtml.php	2008-05-05 19:10:08.000000000 +0200
+++ dokuwiki/inc/parser/xhtml.php	2008-05-24 16:32:16.000000000 +0200
@@ -487,7 +487,7 @@
         resolve_pageid(getNS($ID),$id,$exists);
         $name = $this->_getLinkTitle($name, $default, $isImage, $id);
         if ( !$isImage ) {
-            if ( $exists ) {
+            if ( $exists && (auth_quickaclcheck($id) >= AUTH_READ) ) {
                 $class='wikilink1';
             } else {
                 $class='wikilink2';
diff -aburN dokuwiki-2008-05-05/inc/parserutils.php dokuwiki/inc/parserutils.php
--- dokuwiki-2008-05-05/inc/parserutils.php	2008-05-05 19:10:09.000000000 +0200
+++ dokuwiki/inc/parserutils.php	2008-05-24 16:32:16.000000000 +0200
@@ -619,7 +619,7 @@
  */
 function p_get_first_heading($id, $render=true){
   global $conf;
-  return $conf['useheading'] ? p_get_metadata($id,'title',$render) : null;
+  return ( $conf['useheading'] && (auth_quickaclcheck($id) >= AUTH_READ) ) ? p_get_metadata($id,'title',$render) : null;
 }
 
 /**
diff -aburN dokuwiki-2008-05-05/inc/template.php dokuwiki/inc/template.php
--- dokuwiki-2008-05-05/inc/template.php	2008-05-05 19:10:09.000000000 +0200
+++ dokuwiki/inc/template.php	2008-05-25 20:37:20.000000000 +0200
@@ -819,7 +819,7 @@
 
     // output
     echo $sep;
-    if($exists){
+    if($exists && (auth_quickaclcheck($page) >= AUTH_READ)){
       $title = p_get_first_heading($page);
       if(!$title) $title = $parts[$i];
       tpl_link(wl($page),hsc($title),'title="'.$page.'"');
@@ -833,7 +833,7 @@
   $page = $part.$parts[$i];
   if($page == $conf['start']) return;
   echo $sep;
-  if(page_exists($page)){
+  if(page_exists($page)&& (auth_quickaclcheck($page) >= AUTH_READ)){
     $title = p_get_first_heading($page);
     if(!$title) $title = $parts[$i];
     tpl_link(wl($page),hsc($title),'title="'.$page.'"');
